/**********************************************************************
 * Fill VRAM with specified data. Same as FILVRM, except :            *
 * FILVRM checks if the current screen mode is 0,1,2,3. If so, it     *
 * behaves like the VDP has only 16kRAM. This is to maintain          *
 * compatibility with MSX-1. BIGFIL, however, does not check the      *
 * screen mode and fills the VRAM just as specified by the parameters.*
 * Entry     : VRAM adress                                            *
 *             length                                                 *
 *             data                                                   *
 * Philips, 20 feb 1986                                               *
 **********************************************************************/

bigfil(address,length,data)                  /*******************************/
                                             /* Call BIGFIL in MAIN ROM     */
int  address;                                /* [HL] = address              */
int  length;                                 /* [BC] = length               */
char data;                                   /* [A]  = data                 */
{                                            /*******************************/
  #asm
    pop   IY              ;keep return adres
    pop   DE              ;character (data) in E
    pop   BC              ;length
    pop   HL              ;start video ram adress
    push  HL              ;restore stack
    push  BC              ; -- 
    push  DE              ; --
    push  IY              ; --
    ld    A,E             ;load character in A
    ld    IY,(0FCC1H)     ;Main ROM adres
    ld    IX,016BH        ;BIGFIL call
    call  001CH           ;perform slot call
    ei
  #endasm
}  
