/**********************************************************************
 * DOS1B  Get allocation                                              *
 * 26 feb 1986                                                        *
 * Parameters    : E                                                  *
 * Return        : A, BC, DE, HL, IY                                  *
 * Function      : returns information of a drive specofied by E      *
 *                 int back[6]                                        *
 *                 back[0] = Number of sectors/cluster                *
 *                 back[1] = Sector size                              *
 *                 back[2] = Number of clusters on disk               *
 *                 back[3] = Number of free clusters                  *
 *                 back[4] = Pointer to DPB                           *
 *                 back[5] = Pointer to FAT                           *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>

dos1B (drive,back)
char drive;
int  back[];
{ 
 #asm
   pop     IY        ;save return adddress
   pop     IX        ;var back pointer
   ld      (BACK),IX ;save in var
   pop     DE        ;drive E
   push    DE        ;restore stack
   push    IX        ; --
   push    IY        ; --
   ld      C,01BH    ;get allocation.
   call    5         ;call MSX-Dos
   push    IY        ;save IY waarde
   ld      IY,(BACK) ;pointer to int BACK
   ld      (IY+0),A  ;
   ld      (IY+1),0  ;Number of sectors/cluster
   ld      (IY+2),C  ;Sector size
   ld      (IY+3),B  ; --
   ld      (IY+4),E  ;Number of clusters on disk
   ld      (IY+5),D  ; --
   ld      (IY+6),L  ;Number of free clusters
   ld      (IY+7),H  ; --
   push    IX        ;set waarde IX in HL
   pop     HL        ; --
   ld      (IY+8),L  ;Pointer to DPB
   ld      (IY+9),H  ; --
   pop     HL        ;restore waarde IY
   ld      (IY+10),L ;Pointer to FAT
   ld      (IY+11),H ; --
   ei
 #endasm
}

#asm
BACK:    DS      2   ;define storage pointer van int back[]
#endasm



