/**********************************************************************
 * DOS0B  Console status                                              *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : A                                                  *
 * Function      : if no input from console  Returns 0                *
 *                 else returns 0FFH                                  *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos0B ()
{ 
 #asm
   ld      C,00BH   ;Console status
   call    5        ;call MSX-Dos
   ld      H,0      ;return code
   ld      L,A  
   ei
 #endasm
}
/**********************************************************************
 * DOS00  System reset                                                *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : Nones                                              *
 * Function      : Jumps to 0000H.                                    *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include <define.h>



dos00 ()
{ 
 #asm
   ld      c,000H   ;System reset
   call    5        ;call MSX-Dos
   ei
  #endasm
}
/**********************************************************************
 * DOS0C  Get version number   2.2                                    *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : HL                                                 *
 * Function      : Sets 0 in H register, 22H in L register            *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos0C ()
{ 
 #asm
   ld      C,00CH   ;Get version number
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS21  Random Read                                                 *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Read a record of a file specified by the FCB       *
 *                 pointed to by DE and transfers the record to the   *
 *                 transfer address.                                  *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos21 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,021H   ;Sequential read
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS0D  Disk reset                                                  *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : none                                               *
 * Function      : Sets default drive to (A:)                         *
 *                 sets transferaddress to 80H                        *
 *                 Flushes out all sectors which have been changed    *
 *                 but have not been written to disk.                 *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos0D ()
{ 
 #asm
   ld      C,00DH   ;Reset disk
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS22  Random write                                                *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Write a record of a file specified by the FCB      *
 *                 pointed to by DE and transfers the record from the *
 *                 transfer address to the file.                      *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos22 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,022H   ;Sequential write
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS23  Get file size                                               *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Calculates the file size (a multiple of 128) of    *
 *                 the file specified by the FCB pointed to by DE     *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos23 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,023H   ;Sequential write
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS0E  Select disk                                                 *
 * 26 feb 1986                                                        *
 * Parameters    : E                                                  *
 * Return        : none                                               *
 * Function      : Sets default drive, with a 0 cooresponding to A    *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos0E (drivenr)
int drivenr;
{ 
 #asm
   pop     IY       ;save retiurn address
   pop     DE       ;drivenr
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,00EH   ;Set default drive
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS0F  Open file                                                   *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Opens a file specified by an FCB pointed to by DE. *
 *                 If successful Return 0, else return 0FFH.          *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos0f (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save retiurn address
   pop     DE       ;fcb pointer
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,00FH   ;Open file
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS10  Close file                                                  *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Close a file specified by an FCB pointed to by DE. *
 *                 If successful Return 0, else return 0FFH.          *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos10 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save retiurn address
   pop     DE       ;fcb pointer
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,010H   ;Open file
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS11  Search first                                                *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Searches for the first occurence of a file         *
 *                 specified by an FCB pointed to by DE               *
 *                 If found                                           *
 *                     the directory entry (32 bytes long) is copied  *
 *                     to the transfer address. Returns 0.            *
 *                 Else                                               *
 *                     Returns 0FFH.                                  *
 *                 Wild card characters are permitted in the name     *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos11 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save retiurn address
   pop     DE       ;fcb pointer
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,011H   ;Search first
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS12  Search next                                                 *
 * 26 feb 1986                                                        *
 * Parameters    : none                                               *
 * Return        : A                                                  *
 * Function      : Searches for the next occurence of a file          *
 *                 specified by the last 'search first' function call.*
 *                 If found                                           *
 *                     the directory entry (32 bytes long) is copied  *
 *                     to the transfer address. Returns 0.            *
 *                 Else                                               *
 *                     Returns 0FFH.                                  *
 *                 Wild card characters are permitted in the name     *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos12 ()
{ 
 #asm
   ld      C,012H   ;Search next
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS13  Delete a file                                               *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Deletes a file specified by an FCB pointed to by DE*
 *                 If succesfull Returns 0, else Returns 0FFH.        *
 *                 wild card characters are permitted.                *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos13 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,013H   ;Delete file(s)
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS14  Sequential read                                             *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Read a record of a file specified by the FCB       *
 *                 pointed to by DE and transfers the record to the   *
 *                 transfer address.                                  *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos14 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,014H   ;Sequential read
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS01  Console input                                               *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : A (input karakter)                                 *
 * Function      : Inputs a character from the console                *
 *                 checks control-C and does function 00.             *
 *                 checks control-P and begins echoing to the printer *
 *                 checks control-N and stops echoing to the printer  *
 *                 echoes the input character                         *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos01 ()
{ 
 #asm
   ld      c,001H   ;Console input
   call    5        ;call MSX-Dos
   ld      H,0      ;return character in HL
   ld      L,A
   ei
 #endasm
}


/**********************************************************************
 * DOS02  Console output                                              *
 * 26 feb 1986                                                        *
 * Parameters    : E (output character)                               *
 * Return        : None                                               *
 * Function      : Outputs character in E to the console              *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos02 (character)
char character;
{ 
 #asm
   pop     IY       ;save return adres
   pop     DE       ;get character in E
   push    DE       ;restore stack
   push    IY       ; --
   ld      c,002H   ;Console output
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS04  AUX output                                                  *
 * 26 feb 1986                                                        *
 * Parameters    : E (output character)                               *
 * Return        : None                                               *
 * Function      : Outputs character in E to an AUX device            *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos04 (character)
char character;
{ 
 #asm
   pop     IY       ;save return adres
   pop     DE       ;get character in E
   push    DE       ;restore stack
   push    IY       ; --
   ld      c,004H   ;AUX output
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS03  AUX input                                                   *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : A (input karakter)                                 *
 * Function      : Inputs a character from an AUX device              *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos03 ()
{ 
 #asm
   ld      c,003H   ;AUX inpu
   call    5        ;call MSX-Dos
   ld      H,0      ;return character in HL
   ld      L,A
   ei
 #endasm
}
/**********************************************************************
 * DOS05  LST output                                                  *
 * 26 feb 1986                                                        *
 * Parameters    : E (output character)                               *
 * Return        : None                                               *
 * Function      : Outputs character in E to then printere            *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos05 (character)
char character;
{ 
 #asm
   pop     IY       ;save return adres
   pop     DE       ;get character in E
   push    DE       ;restore stack
   push    IY       ; --
   ld      c,005H   ;LST output
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS06  Direcy console I/O                                          *
 * 26 feb 1986                                                        *
 * Parameters    : E                                                  *
 * Return        : A                                                  *
 * Function      : If E is 0FFH                                       *
 *                    if no input from the console                    *
 *                          return 0                                  *
 *                    else  returns the code                          *
 *                          No check.                                 *
 *                          No echo.                                  *
 *                 Else                                               *
 *                    Outputs character in E to the console           *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos06 (character)
char character;
{ 
 #asm
   pop     IY       ;save return adres
   pop     DE       ;get character in E
   push    DE       ;restore stack
   push    IY       ; --
   ld      c,006H   ;Direct console I/O
   call    5        ;call MSX-Dos
   ld      H,0      ;return code in HL
   ld      L,A
   ei
 #endasm
}
/**********************************************************************
 * DOS07  Direct input                                                *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : A                                                  *
 * Function      : Input character from the console                   *
 *                          No check.                                 *
 *                          No echo.                                  *
 * CP/M Comp.    : N0 (get I/O byte)                                  *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos07 ()
{ 
 #asm
   ld      c,007H   ;Direct input
   call    5        ;call MSX-Dos
   ld      H,0      ;return code in HL
   ld      L,A
   ei
 #endasm
}
/**********************************************************************
 * DOS08  Direct input                                                *
 * 26 feb 1986                                                        *
 * Parameters    : None                                               *
 * Return        : A                                                  *
 * Function      : Input character from the console                   *
 *                 Checks for control-C.                              *
 *                 Checks for control-P                               *
 *                 Checks for control-N                               *
 *                 no echo                                            *
 * CP/M Comp.    : N0 (set I/O byte)                                  *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos08 ()
{ 
 #asm
   ld      c,008H   ;Direct input
   call    5        ;call MSX-Dos
   ld      H,0      ;return code in HL
   ld      L,A
   ei
 #endasm
}
/**********************************************************************
 * DOS09  String output                                               *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : none                                               *
 * Function      : Outputs the string pointed to by DE to the console *
 *                 until a '$' is encountered in the given string     *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos09 (string)
char *string;
{ 
 #asm
   pop     IY       ;save return adress
   pop     DE       ;pointer naar tekst
   push    DE       ;restore stack
   push    IY
   ld      c,009H   ;String output
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS0A  Buffered input                                              *
 * 26 feb 1986                                                        *
 * Parameters    : DE (string pointer)                                *
 * Return        : none                                               *
 * Function      : Inputs the string from console beginning at [DE+2] *
 *                 until a CR code is input.                          *
 *                 [DE+1] is set to the length of input string, not   *
 *                 including the terminator                           *
 *                 the maximum length of the string is passed via [DE]*
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos0A (buff_input)
char *buff_input;
{ 
 #asm
   pop     IY       ;save return adress
   pop     DE       ;pointer to input
   push    DE       ;restore stack
   push    IY
   ld      C,00AH   ;String output
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS15  Sequential write                                            *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Write a record of a file specified by the FCB      *
 *                 pointed to by DE and transfers the record from the *
 *                 transfer address to the file.                      *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos15 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,015H   ;Sequential write
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS16  create a file                                               *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : create a file specified by an FCB pointed to by DE *
 *                 if the specified file already exists, it is over-  *
 *                 written.     
 *                 If successful Return 0, else Return 0FFH.          *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos16 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,016H   ;Rename a file
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS17  rename file                                                 *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : renames a file specified by an FCB pointed to by DE*
 *                 to a file name specified by an FCB pointed to by   *
 *                 DE+16.
 *                 If successful Return 0, else Return 0FFH.          *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos17 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,017H   ;Rename a file
   call    5        ;call MSX-Dos
   ld      H,0      ;setup return code
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS18  Get login vector                                            *
 * 26 feb 1986                                                        *
 * Parameters    : none                                               *
 * Return        : HL                                                 *
 * Function      : returns a bit table for on-line drives. unlike     *
 *                 CP/M, all system drives are online.                *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos18 ()
{ 
 #asm
   ld      C,018H   ;Get login vector
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS19  get default drive name                                      *
 * 26 feb 1986                                                        *
 * Parameters    : none                                               *
 * Return        : A                                                  *
 * Function      : gets the defaukt drive name                        *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos19 ()
{ 
 #asm
   ld      C,019H   ;Get login vector
   call    5        ;call MSX-Dos
   ld      H,0      ;return code
   ld      L,A
   ei
 #endasm
}
/**********************************************************************
 * DOS1A  Set dma address                                             *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : None                                               *
 * Function      : Sets transfer address.                             *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos1A (dmaaddress)
char *dmaaddress;
{ 
 #asm
   pop     IY       ;save return adddress
   pop     DE       ;trabnsfer address
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,01AH   ;Set dma address.
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS1B  Get allocation                                              *
 * 26 feb 1986                                                        *
 * Parameters    : E                                                  *
 * Return        : A, BC, DE, HL, IY                                  *
 * Function      : returns information of a drive specofied by E      *
 *                 int back[6]                                        *
 *                 back[0] = Number of sectors/cluster                *
 *                 back[1] = Sector size                              *
 *                 back[2] = Number of clusters on disk               *
 *                 back[3] = Number of free clusters                  *
 *                 back[4] = Pointer to DPB                           *
 *                 back[5] = Pointer to FAT                           *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>

dos1B (drive,back)
char drive;
int  back[];
{ 
 #asm
   pop     IY        ;save return adddress
   pop     IX        ;var back pointer
   ld      (BACK),IX ;save in var
   pop     DE        ;drive E
   push    DE        ;restore stack
   push    IX        ; --
   push    IY        ; --
   ld      C,01BH    ;get allocation.
   call    5         ;call MSX-Dos
   push    IY        ;save IY waarde
   ld      IY,(BACK) ;pointer to int BACK
   ld      (IY+0),A  ;
   ld      (IY+1),0  ;Number of sectors/cluster
   ld      (IY+2),C  ;Sector size
   ld      (IY+3),B  ; --
   ld      (IY+4),E  ;Number of clusters on disk
   ld      (IY+5),D  ; --
   ld      (IY+6),L  ;Number of free clusters
   ld      (IY+7),H  ; --
   push    IX        ;set waarde IX in HL
   pop     HL        ; --
   ld      (IY+8),L  ;Pointer to DPB
   ld      (IY+9),H  ; --
   pop     HL        ;restore waarde IY
   ld      (IY+10),L ;Pointer to FAT
   ld      (IY+11),H ; --
   ei
 #endasm
}

#asm
BACK:    DS      2   ;define storage pointer van int back[]
#endasm



/**********************************************************************
 * DOS24  Set Random record                                           *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : None                                               *
 * Function      : Calculates the current record position from the    *
 *                 current record field of the given FCB.             *
 * CP/M Comp.    : YES                                                *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos24 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,024H   ;Set random record
   call    5        ;call MSX-Dos
   ei
 #endasm
}
/**********************************************************************
 * DOS26  Random block write                                          *
 * 26 feb 1986                                                        *
 * Parameters    : DE,HL                                              *
 * Return        : A                                                  *
 * Function      : Writes records to a file specified by the FCB      *
 *                 pointed to by DE from the transfer address. The nr *
 *                 of records to write is passed via HL               *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos26 (fcb,number)
char *fcb;
int  number;
{ 
 #asm
   pop     IY       ;save return address
   pop     HL       ;number of record's
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    HL       ; --
   push    IY       ; --
   ld      C,026H   ;Random block write
   call    5        ;call MSX-Dos
   ld      H,0      ;return waarde
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS27  Random block read                                           *
 * 26 feb 1986                                                        *
 * Parameters    : DE,HL                                              *
 * Return        : A (HL)                                             *
 * Function      : Read records from a file specified by the FCB      *
 *                 pointed to by DE from the transfer address. The nr *
 *                 of records to read is passed via HL, the number    *
 *                 actually read is returned in HL                    *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos27 (fcb,number)
char *fcb;
int  *number;
{ 
 #asm
   pop   IY          ;save return address
   pop   IX          ;address number of record's
   ld    H,(IX+1)    ;get waarde
   ld    L,(IX)      ; --
   pop   DE          ;pointer to fcb
   push  DE          ;restore stack
   push  IX          ; --
   push  IY          ; --
   ld    C,027H      ;Sequential write
   call  5           ;call MSX-Dos
   pop   IY          ;get returnaddress
   pop   IX          ;address of number of record's
   ld    (IX+1),H    ;save 
   ld    (IX),L      ; --
   pop   IX          ;restore stack
   pop   IY          ; --
   ld    H,0         ;return waarde
   ld    L,A         ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS28  Random write with zero fill                                 *
 * 26 feb 1986                                                        *
 * Parameters    : DE                                                 *
 * Return        : A                                                  *
 * Function      : Writes records to a file specified by the FCB      *
 *                 pointed to by DE from the transfer address.        *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos28 (fcb)
char *fcb;
{ 
 #asm
   pop     IY       ;save return address
   pop     DE       ;pointer to fcb
   push    DE       ;restore stack
   push    IY       ; --
   ld      C,028H   ;Random write with zero fill
   call    5        ;call MSX-Dos
   ld      H,0      ;return waarde
   ld      L,A      ; --
   ei
 #endasm
}
/**********************************************************************
 * DOS2F  Absolute disk read                                          *
 * 26 feb 1986                                                        *
 * Parameters    : H,L,DE                                             *
 * Return        : none                                               *
 * Function      : Read H sectors from logical sector number DE on    *
 *                 the drive specified by L to the transfer address   *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos2F (drive,sector,number)
int drive,sector,number;
{ dos2F0 (number*256+drive,sector);
}

dos2F0 (da,ts)
int da,ts;
{ 
 #asm
   pop     IY       ;hold return address
   pop     DE       ;Sector nr
   pop     HL       ;aantal + drivenr
   push    HL       ;restore stack
   push    DE       ; --
   push    IY       ; --
   ld      c,02FH   ;funktie 2F read sector on disk
   call    5        ;call MSX-Dos
   ei
  #endasm
}
/**********************************************************************
 * DOS30  Absolute disk write                                         *
 * 26 feb 1986                                                        *
 * Parameters    : H,L,DE                                             *
 * Return        : none                                               *
 * Function      : Writes H sectors from logical sector number DE on  *
 *                 the drive specified by L from the transfer address *
 * CP/M Comp.    : NO                                                 *
 **********************************************************************/

#include  <stdio.h>
#include  <define.h>



dos30 (drive,sector,number)
int drive,sector,number;
{ dos300 (number*256+drive,sector);
}

dos300 (da,ts)
int da,ts;
{ 
 #asm
   pop     IY       ;hold return address
   pop     DE       ;Sector nr
   pop     HL       ;aantal + drivenr
   push    HL       ;restore stack
   push    DE       ; --
   push    IY       ; --
   ld      c,030H   ;absolute disk write
   call    5        ;call MSX-Dos
   ei
  #endasm
}
