/**********************************************************************
 * call DOS MAIN ROM                                                  *
 * 14 feb 1986                                                        *
 **********************************************************************/

#include  <stdio.h>

/**********************************************************************/
/* Funktie naam :DOSMAIN                                              */
/*                                                                    */
/* dosmain (func, AF, BC, DE, HL, back)                               */
/*                                                                    */
/* int    func  = functie code                                        */
/* int    AF    = register AF                                         */
/* int    BC    = register BC                                         */
/* int    DE    = register DE                                         */
/* int    HL    = register HL                                         */
/* char   *back = terugkom block  (min 5 bytes)                       */
/*                                                                    */
/*        BLOCK[0] = register A                                       */
/*        BLOCK[1] = register B                                       */
/*        BLOCK[2] = register C                                       */
/*        BLOCK[3] = register D                                       */
/*        BLOCK[4] = register E                                       */
/* de procedure is een funktie een geeft de return waarde HL          */
/**********************************************************************/


dosmain (func, XAF, XBC, XDE, XHL, back)
int  func;
int  XAF, XBC, XDE, XHL;
char *back;
{    
  #asm
    pop   IY              ;onthou return adres
    ld    (ASTACK),IY
    pop   IY              ;back pointer
    ld    (ABACK),IY 
    pop   HL              ;HL register
    pop   DE              ;DE register
    pop   BC              ;BC register
    pop   AF              ;AF register
    pop   IX              ;funktie code
    push  IX              ;restore stack
    push  AF
    push  BC
    push  DE
    push  HL
    ld    IY,(ABACK)
    push  IY
    ld    IY,(ASTACK)
    push  IY
    ld    IY,(0FCC1H)     ;Main ROM adres
    call  0001CH          ;perform slot call
    ei
    ld    IY,(ABACK)      ;pointer naar blok
    ld    (IY+0),A
    ld    (IY+1),B
    ld    (IY+2),C
    ld    (IY+3),D
    ld    (IY+4),E
  #endasm
}   

#asm
ASTACK:    DW
ABACK:     DW
#endasm

